<?php

class m121205_102018_vote extends CDbMigration
{
	// Use safeUp/safeDown to do migration with transaction
	public function safeUp()
	{
            $this->createTable('{{question}}', array(
                            'id' => 'string',
                            'author_id' => 'integer',
                            'text' => 'text',
                            'created' => 'datetime',
                            'PRIMARY KEY (id)'
                        ));
            $this->createTable('{{answer}}', array(
                            'id' => 'pk',
                            'question_id' => 'string',
                            'answer_key' => 'string',
                            'order' => 'integer DEFAULT 0',
                            'text' => 'text',
                            'active' => 'integer',
                            'created' => 'datetime',
                        ));
            $this->createIndex('question_id_idx', '{{answer}}', 'question_id');
            $this->createTable('{{user_answer}}', array(
                            'answer_id' => 'integer',
                            'user_id' => 'string', //for anonymous user use session id as key
                            'additional' => 'text',
                            'created' => 'datetime',
                        ));
            $this->createIndex('answer_user_id_idx', '{{user_answer}}', 'user_id');
	}

	public function safeDown()
	{
            $this->dropTable('{{question}}');
            $this->dropTable('{{answer}}');
            $this->dropTable('{{user_answer}}');
	}

}
