<?php
/**
 * Created by JetBrains PhpStorm.
 * User: Andrey
 * Date: 1/17/14
 * Time: 1:01 PM
 * To change this template use File | Settings | File Templates.
 */

class CommentLinkPager extends CLinkPager
{
    public $contentId;
    /**
     * Creates the URL suitable for pagination.
     * @param integer $page the page that the URL should point to.
     * @return string the created URL
     * @see CPagination::createPageUrl
     */
    protected function createPageUrl($page)
    {
        $url = Yii::app()->request->getUrl();
        $name = "clw{$this->contentId}";
        $newParam = "clw{$this->contentId}=$page";
        if (($oldValue = Yii::app()->request->getParam($name)) !== null) {
            $url = str_replace("$name=$oldValue", $newParam, $url);
        } else {
            if (strpos($url, '?') !== false) {
                $url .= '&' . $newParam;
            } else {
                $url .= '?' . $newParam;
            }
        }
        $url .= '#list_' . $this->contentId;

        return $url;
    }

    /**
     * @param boolean $recalculate whether to recalculate the current page based on the page size and item count.
     * @return integer the zero-based index of the current page. Defaults to 0.
     * @see CPagination::getCurrentPage
     */
    public function getCurrentPage($recalculate=true)
    {
        return Yii::app()->request->getParam("clw{$this->contentId}", 0);
    }

}