/*
 * Surfacing of the layouts (dom elements)
 * clicking on element will set its z-index higher then else elements added to surfacing ui
 * Works only if element has "position: [absolute / relative]" css style
 */
(function($) {
	
	$.surfacing = {
		
			/**
			 * @desc elements to work with
			 */
			stack: [],
			/**
			 * @desc min css z-index
			 */
			minZIndex: 1,
		
		pushUp: function(el)
		{
			var stackLength = this.stack.length - 1;
			var elStackIndex = this.stack.indexOf(el);
			var elIndex = this._getIndex(el);
			$(this.stack).each( $.proxy( function(k, v) {
				var vIndex = this._getIndex(v);
				if(vIndex > elIndex) {
					this._setIndex(v, vIndex-this.minZIndex-1);
				}
			}, this ) );
			this._setIndex(el, stackLength);
		},
		
		_setIndex: function(el, index)
		{
			$(el).css('z-index', this.minZIndex + index);
		},
		
		_getIndex: function(el)
		{
			return $(el).css('z-index');
		}
		
	};
	
	$.fn.surfacing = function()
	{
		var index = $.surfacing.stack.push(this.get(0))-1;
		$.surfacing._setIndex(this, index);
		this.mousedown(function() {
			$.surfacing.pushUp(this);
		});
	}
	
})(jQuery);