<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 */

    if (!$this->isBreadcrumb || $lvl==1) {
?>
    <ul class="<?php echo $this->cssClass; ?> lvl<?php echo $lvl; ?>">
<?php
    }

    foreach ($branch as $index => $item) {
        if ($this->isBreadcrumb && !(in_array($item['contentid'], $this->activePath))){
            continue;
        }
        ?>
        <li>
            <?php
                $name   = NavigationTree::getBranchName($item, $this->lang);
                $url    = NavigationTree::getStartpageUrl($item, $this->lang);
                $excludeURLs = Yii::app()->getModule('navigation')->excludeURLs;
                // If startpageurl is one those that should be excluded or empty - exclude it
                if (empty($url) || in_array($url, $excludeURLs)) {
                    unset($branch[$index]);
                    continue;
                }

                $hasChildrenClass = !empty($item['children']) ? 'has-children' : '';
                if (strpos($url, 'http') === false) {
                    if (in_array($item['contentid'], $this->activePath)) {
                        echo CHtml::link($name, Yii::app()->createUrl($url), array('class'=>'active '.$hasChildrenClass));
                    } else {
                        echo CHtml::link($name, Yii::app()->createUrl($url), array('class'=>$hasChildrenClass));
                    }
                } else {
                    echo CHtml::link($name, $url, array('class'=>$hasChildrenClass));
                }

                /* if current node has children and children's lvl does not go out of maxLvl - then show it */
                if (isset($item['children']) && (in_array($item['contentid'], $this->activePath) || $this->isSitemap) && ($this->maxLvl == 0 || $lvl < $this->maxLvl)) {
                    $this->render('_branch', array('branch'=>$item['children'], 'lvl'=>($lvl+1)));
                }
            ?>
        </li>
        <?php
    }
    if (!$this->isBreadcrumb || $lvl==1) {
?>
</ul>
<?php
    }
?>