<?php

/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 * Last visited pages
 *
 **/
class MostVisitedPages extends CJuiWidget
{

    /**
     * Piwik-Token to identify 
     *
     * @var string
     **/
    public $token;

    /**
     * url to the Piwik-Service
     *
     * @var string
     **/
    public $piwikServerURL;

    /**
     * commaseperated list of sites OR "all"
     *
     * @var string
     **/
    public $sites;

    /**
     * Amount of displaying items
     *
     * @var string
     **/
    public $count;

    /**
     * How long the Pages-Array will be cached
     *
     * @var string
     **/
    public $cacheTime;

    /**
     * Find pages, display
     *
     **/
    public function run()
    {
        if (empty($this->count))
            $this->count = Yii::app()->getModule('piwik')->count;
        if (empty($this->token))
            $this->token = Yii::app()->getModule('piwik')->token;
        if (empty($this->piwikServerURL))
            $this->piwikServerURL = Yii::app()->getModule('piwik')->piwikServerURL;
        if (empty($this->sites))
            $this->sites = Yii::app()->getModule('piwik')->sites;
        if (empty($this->cacheTime))
            $this->cacheTime = Yii::app()->getModule('piwik')->cacheTime;

        $mostvisited = array();
        
        $check = Yii::app()->cache->get(md5($this->sites ."_popular"));
        
        if (!empty($check)){
            $mostvisited = $check;
        } else {

            $url = $this->piwikServerURL;
            $url .= "/?module=API&method=Actions.getPageUrls";
            $url .= "&idSite=".$this->sites."&period=month&date=yesterday";
            $url .= "&format=PHP&filter_limit=".$this->count;
            $url .= "&filter_sort_column=nb_hits&filter_sort_order=desc";
            $url .= "&token_auth=".$this->token;

            $fetched = file_get_contents($url);
            $content = unserialize($fetched);
            
            if ($this->sites == "all" || strstr($this->sites,',')){
                foreach($content as $mysiteid => $mysite){
                    foreach($mysite as $myline){
                        $mostvisited[] = $this->calcresult($myline);
                    }
                    $key = md5($mysiteid ."_popular");
                    Yii::app()->cache->set($key, $mostvisited, $this->cacheTime);
                }
                $key = md5($this->sites ."_popular");
                Yii::app()->cache->set($key, $mostvisited, $this->cacheTime);
                
            } else {
                foreach($content as $myline){
                    $mostvisited[] = $this->calcresult($myline);
                }
                $key = md5($this->sites ."_popular");
                Yii::app()->cache->set($key, $mostvisited, $this->cacheTime);
                
            }
        }    
        $this->render($mostvisited);
    }    

    private function calcresult($line){
        return array("url" => $line['url'], "name" => $line['label']);
    }

    public function render($mostvisited){
        foreach($mostvisited as $h){
            $name = (!empty($h['name']) ? $h['name'] : $h['url']);
            $cmsObject = Yii::app()->getComponent("repositoryApi")->getCmsObject($h['name'], array("name"));
            if (!empty($cmsObject)){
                $name = $cmsObject["attributes"]["name"];
            }
            echo "<li>".CHtml::link($name, $h['url'])."</li>";
        }
    }
}
